# This is the file you should use to write your code for the implementation problem.
# Do not change the name of this file.
# Please do not include print statements outside the provided functions, as this may crash the autograder.
# You may add any function definition as you see appropriate.
# The file should not contain the if __name__ == '__main__' block upon submission (You can comment it out if you used it in your development process).

import pickle
import torch
import torch.nn as nn
from torch.utils.data import Dataset, DataLoader

# Add imports below as you see fit. The packages you are allowed to use include:
# Pytorch, scikit-learn, NumPy, matplotlib


# This is the provided Dataloader class. You SHOULD NOT change this.
# Tip: You can load your training data with the following lines:
# train_data = MyData('train')
# train_loader = DataLoader(train_data,batch_size=BATCH_SIZE)
# where you define the constant BATCH_SIZE beforehand
# For more information on the Dataloader, see https://pytorch.org/tutorials/beginner/basics/data_tutorial.html
class MyData(Dataset):
    def __init__(self, mode):
        with open(mode+'.pkl', 'rb') as handle:
            data = pickle.load(handle)
            self.X = data['x'].astype('float')
            self.y = data['y'].astype('long')

    def __len__(self):
        return len(self.X)

    def __getitem__(self, idx):
        if torch.is_tensor(idx):
            idx = idx.tolist()

        sample = (self.X[idx], self.y[idx])

        return sample

# Do NOT change the headline of the class.
# This class should contain your model architecture.
# Usually this means it should contain an init function and a forward function.
# Note that things like training and evaluation
# should be put under a separate function definition OUTSIDE this class.
# Please make sure we can load your model with:
# model = MyModel()
# This means you must give default values to all parameters you may wish to set, such as output size.
class MyModel(nn.Module):
    pass

# You SHOULD NOT change this function. Instead, use it to save your TRAINED model properly.
# The parameter [model] is the TRAINED torch model you wish to save.
# For more information, see https://pytorch.org/tutorials/beginner/saving_loading_models.html
def save_model(model):
    torch.save(model.state_dict(), "mymodel.pth")

# We are going to load your model with:
# model = MyModel()
# model = torch.load("mymodel.pth")
# And run your model on our test set, then grade based on your test accuracy
